package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.EmpresaEmailEComerceDAO;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.EmpresaEmailEComerce;

@Repository("empresaEmailEComerceDAO")
public class EmpresaEmailEComerceHibernateDAO extends GenericHibernateDAO<EmpresaEmailEComerce, Integer>
		implements EmpresaEmailEComerceDAO {

	@Autowired
	public EmpresaEmailEComerceHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
		setSessionFactory(factory);
	}

	@Override
	public List<EmpresaEmailEComerce> obtenerTodos() {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

		return c.list();
	}

	@Override
	public EmpresaEmailEComerce buscarPorEmpresa(Empresa empresa, String tipoOperacao) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
		c.add(Restrictions.eq("empresa", empresa));
		c.add(Restrictions.eq("tipoOperacao", tipoOperacao));

		return (EmpresaEmailEComerce) c.uniqueResult();
	}
}
